package com.ssm.manage.service.impl;

import com.github.pagehelper.PageInfo;
import com.ssm.core.service.impl.BaseServiceImpl;
import com.ssm.manage.dao.SsmSysCompanyStoreDao;
import com.ssm.manage.entity.SmsException;
import com.ssm.manage.entity.SysCompany;
import com.ssm.manage.entity.SysCompanyStore;
import com.ssm.manage.query.SysCompanyRequest;
import com.ssm.manage.query.SysCompanyStoreRequest;
import com.ssm.manage.query.UserRequest;
import com.ssm.manage.response.UserResponse;
import com.ssm.manage.service.SsmSysCompanyStoreService;
import com.ssm.util.RedisClient;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import static com.ssm.manage.service.impl.SsmStaffWorksServiceImpl.getKey;

@Service
public class SsmSysCompanyStoreServiceImpl   extends BaseServiceImpl<SysCompanyStore> implements SsmSysCompanyStoreService {
    @Autowired
    private SsmSysCompanyStoreDao dao;

    @Autowired
    public RedisClient<UserResponse> redisClient;

    @Override
    public SsmSysCompanyStoreDao getDao() {
        return dao;
    }

    @Override
    public PageInfo<SysCompanyStore> selectPage(SysCompanyStoreRequest sysCompanyStoreRequest) {
        return dao.selectPage(sysCompanyStoreRequest);
    }

    @Override
    public int saveSysCompanyStore(List<SysCompanyStoreRequest> sysCompanyStores, String userNum) throws SmsException {

        List<SysCompanyStore> companyStoreList = new ArrayList<>();
        for (SysCompanyStoreRequest sysCompanyStore : sysCompanyStores) {
            SysCompanyStore sysCompanyStore1 = new SysCompanyStore();
            if (redisClient.hasKey(getKey(userNum))){
                UserResponse userResponse = redisClient.get(getKey(userNum));
                sysCompanyStore1.setFunderName(userResponse.getUserName());
                sysCompanyStore1.setFunderDate(new Date());
            }
            sysCompanyStore1.setCompanyStoreId(sysCompanyStore.getCompanyStoreId());
            sysCompanyStore1.setCompanyCode(sysCompanyStore.getCompanyCode());
            sysCompanyStore1.setCompanyId(sysCompanyStore.getCompanyId());
            sysCompanyStore1.setStoreId(sysCompanyStore.getStoreId());
            sysCompanyStore1.setCompanyName(sysCompanyStore.getCompanyName());
            sysCompanyStore1.setStoreNum(sysCompanyStore.getStoreNum());
            sysCompanyStore1.setStoreName(sysCompanyStore.getStoreName());

            companyStoreList.add(sysCompanyStore1);
        }
        //设置主键
        int i = dao.insertList(companyStoreList);
        return i;
    }

    @Override
    public int updateSysCompanyStore(SysCompanyStore sysCompanyStore, String userNum) throws SmsException {
        //从redis获取当前操作人信息 将修改用户的修改人和修改时间进行赋值
        if (redisClient.hasKey(getKey(userNum))){
            UserResponse userResponse = redisClient.get(getKey(userNum));
            sysCompanyStore.setUpdatedName(userResponse.getUserName());
            sysCompanyStore.setUpdatedDate(new Date());
        }
        int i = dao.updateByPrimaryKeySelective(sysCompanyStore);
        return i;
    }

    @Override
    public int deleteSingleSysCompanyStore(SysCompanyStoreRequest sysCompanyStore) {
        return dao.deleteByPrimaryKey(sysCompanyStore.getCompanyStoreId());
    }

}
